' Anzeige Fortschrittsbalken. Version mit vollem Balken.
'   Prozeduren: Fortschritt_Beginn, Fortschritt_Anzeige, Fortschritt_Ende

' Version 3.0  29.9.2002.      Die Prozedur kann frei benutzt werden, fr
'                              Schden kann keine Haftung bernommen werden.
' Autor: Gerhard Putschalka
'                       email: g.putschalka@web.de
'                    homepage: http://members.telering.at/g.putschalka/index.html

' Beschreibung der Prozedur und Testprogramm ist in QFANZGE.Prf

Declare P_Wnd%,P_Track%,P_Val&,P_End&,P_Wide& ' global definiert (auerhalb der Prozedur)

Proc Fortschritt_Beginn      ' Progressbar Fenster ffnen.
   ' Parameters ElternfensterHandle, X und Y Koordinate fr den Dialog, Breite fr den    
   ' Dialog, Text fr Dialog, FixText fr die erste Zeile, EndWert
   Let P_End& = @&(7)
   Let P_Wide& = @&(4)
   Let P_Wnd% = @Createdialog(@%(1),@$(5),@&(2),@&(3),@&(4),110)

   StartPaint P_Wnd%
   UsePen 0,3,@RGB(230,230,230)
   Line 11,60-@Sub(@&(4),15),60
   LineTo @Sub(@&(4),15),38
   UsePen 0,3,@RGB(130,130,130)
   Line 11,38-@Sub(@&(4),17),38
   Line 9,38-9,60
   EndPaint   
   @CreateText(P_Wnd%,@$(6),10,0,450,14)   
   Let P_Val&=0
   Return
EndProc

Proc Fortschritt_Anzeige      ' Parameters Wert,Text
  ' Wert ist momentaner Wert, Endwert ergibt 100%

   Declare A%,X%,NewPrz%
   Let X% = @Sub(P_Wide&,15)         ' ist Balkenende

   Let A% = @Sub(X%,20) ' Balkenlnge: der Balken beginnt bei 20 und endet bei 280
   StartPaint P_Wnd%

   ' berechne % aus Wert im Verhltnis zum Endwert
   Let NewPrz% = @Div&(@Mul(@%(1),100),P_End&)

   ' berechne Lnge des blauen Balkens
    Let A% = @Div&(@Mul(NewPrz%,@Sub(P_Wide&,35)),100)

   UseBrush 1,@RGB(150,150,150)
   Rectangle 10,40-X%,60
   UseBrush 1,@RGB(50,50,255)
   Rectangle 10,40-@Add(A%,20),60
   EndPaint
   If (%PCount > 1) ' Text wurde angegeben

   @CreateText(P_Wnd%,@$(2),10,16,450,14)


   EndIf
   @CreateText(P_Wnd%,@add$(str$(NewPrz%),"%"),@Sub(@Div(P_Wide&,2),20),65,45,14)
   Return
EndProc

Proc Fortschritt_Ende    ' Fenster wieder schlieen
   @DestroyWindow(P_Wnd%)
   Return
EndProc
